#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct ArrayListNodeType {
	int data;
} ArrayListNode;

typedef struct ArrayListType {
	int maxCount;           // ִ ڷ : 迭 ũ
	int currentCount;       //  ڷ 
	ArrayListNode *pData;   // ڷ   1 迭
} ArrayList;

ArrayList *createList(int count)
{
	ArrayList *pReturn = NULL;

	if (count > 0) {
		pReturn = (ArrayList *)malloc(sizeof(ArrayList));
		if (pReturn != NULL) {
			pReturn->maxCount = count;
			pReturn->currentCount = 0;
			pReturn->pData = NULL;
		}
		else {
			printf(", ޸Ҵ createList()\n");
			return NULL;
		}
	}
	else {
		printf(", ִ   0̻̾ մϴ\n");
		return NULL;
	}

	pReturn->pData = (ArrayListNode *)malloc(sizeof(ArrayListNode) * count);
	if (pReturn->pData == NULL) {
		printf(", 2° ޸Ҵ createArrayList()\n");
		free(pReturn); return NULL;
	}
	memset(pReturn->pData, 0, sizeof(ArrayListNode) * count);

	return pReturn;
}

int addListData(ArrayList* pList, int position, int data)
{
	int ret = 0;
	int i = 0;
	if (pList != NULL) {
		if (pList->currentCount < pList->maxCount) {
			if (position >= 0 && position <= pList->currentCount)
			{
				for (i = pList->currentCount - 1; i >= position; i--) {
					pList->pData[i + 1] = pList->pData[i];
				}
				pList->pData[position].data = data;
				pList->currentCount++;
			}
			else {
				printf(", ġ ε-[%d]  ʰ, addALElement()\n", position);
				ret = 2;
			}
		}
		else {
			printf(", Ʈ 뷮 ʰ-[%d]/[%d]\n", position, pList->maxCount);
			ret = 2;
		}
	}
	else {
		ret = 1;
	}
	return ret;
}

int removeListData(ArrayList* pList, int position)
{
	int ret = 0;
	int i = 0;
	if (pList != NULL) {
		if (position >= 0 && position < pList->currentCount) {
			for (i = position; i < pList->currentCount - 1; i++) {
				pList->pData[i] = pList->pData[i + 1];
			}
			pList->currentCount--;
		}
		else {
			printf(", ġ ε-[%d]  ʰ, removeListData()\n", position);
			ret = 2;
		}
	}
	else {
		ret = 1;
	}

	return ret;
}

int getListData2(ArrayList* pList, int position, int *pResult) {
	int ret = 0;
	if (pList != NULL) {
		if (position >= 0 && position < pList->currentCount) {
			*pResult = pList->pData[position].data;
		}
		else {
			printf(", ġ ε-[%d]  ʰ, getListData2()\n", position);
			ret = 2;
		}
	}
	else {
		ret = 1;
	}


	return ret;
}

int getListData(ArrayList* pList, int position)
{
	return pList->pData[position].data;
}

void deleteList(ArrayList* pList)
{
	if (pList != NULL) {
		if (pList->pData != NULL) {
			free(pList->pData);
		}
		free(pList);
	}
}

int getListLength(ArrayList* pList)
{
	if (pList != NULL)
	{
		return pList->currentCount;
	}
	return 0;
}

int main(int argc, char *argv[])
{
	ArrayList *pList = NULL;
	int value = 0;
	int status = 0;

	pList = createList(5);              // Step-1
	addListData(pList, 0, 10);          // Step-2
	addListData(pList, 1, 20);          // Step-3
	addListData(pList, 0, 30);          // Step-4

	value = getListData(pList, 1);      // Step-5
	printf("ġ: %d, : %d\n", 1, value);

	status = getListData2(pList, 4, &value);
	if (0 == status) {
		printf("ġ: %d, : %d\n", 4, value);
	}

	value = getListLength(pList);
	printf("ڷ : %d\n", value);

	removeListData(pList, 0);           // Step-6
	deleteList(pList);                  // Step-7

	return 0;
}
