#ifndef _LINKEDQUEUE_
#define _LINKEDQUEUE_

#include "bintree.h"

typedef struct LinkedQueueNodeType
{
    BinTreeNode* data;
    struct LinkedQueueNodeType* pLink;
} LinkedQueueNode;

typedef struct LinkedQueueType
{
    int currentCount;   //   
    LinkedQueueNode* pFront;  // Front  
    LinkedQueueNode* pRear;   // Rear  
} LinkedQueue;

int isLinkedQueueEmpty(LinkedQueue* pQueue);
LinkedQueue* createLinkedQueue();
int enqueueLQ(LinkedQueue* pQueue, BinTreeNode* data);
LinkedQueueNode* dequeueLQ(LinkedQueue* pQueue);
LinkedQueueNode* peekLQ(LinkedQueue* pQueue);
void deleteLinkedQueue(LinkedQueue* pQueue);
int isLinkedQueueEmpty(LinkedQueue* pQueue);
void displayLinkedQueue(LinkedQueue *pQueue);

#endif
