#ifndef _LINKEDLIST_
#define _LINKEDLIST_

typedef struct LinkedListNodeType {
    int data;		//  ID
	int weight;		// ġ
    struct LinkedListNodeType *pLink;
} LinkedListNode;

typedef struct LinkedListType {
    LinkedListNode  headerNode;
    int             currentCount;
} LinkedList;

LinkedList *createLinkedList();
// ߰ Լ: position ġ 带 ȯ
LinkedListNode *getLinkedListNode(LinkedList* pList, int position);
int getLinkedListData(LinkedList* pList, int position);
// Ķ weight ߰.
int addLinkedListData(LinkedList* pList, int position, int data, int weight);
int removeLinkedListData(LinkedList* pList, int position);
void deleteLinkedList(LinkedList* pList);
int getLinkedListLength(LinkedList* pList);

#endif
